SystemOrganization addCategory: #PluggableTextMorphWithLimits!

PluggableTextMorph subclass: #PluggableTextMorphWithLimits
	instanceVariableNames: 'warningLimit alertLimit'
	classVariableNames: 'DefaultWarningLimit'
	poolDictionaries: ''
	category: 'PluggableTextMorphWithLimits'!

!PluggableTextMorphWithLimits commentStamp: '<historical>' prior: 0!
I have a warningLimit ( 350 by default ) and an alertLimit ( 2* warningLimit by default ), and the number of characters of the text displayed is counted ( without space, tabs, cr etc).

If my text size is below the warning limit, the background is white ( or the default color ), if it is between warningLimit and alertLimit, the background turn more and more yellow, and if it's above the alertLimit, the background turn orange :)

Test it with: 

self example!

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:38'!
defaultWarningLimit

	^ DefaultWarningLimit ifNil: [ DefaultWarningLimit := 350 ]! !

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:29'!
defaultWarningLimit: anInteger
	" self defaultWarningLimit:nil "

	DefaultWarningLimit := anInteger! !

!PluggableTextMorphWithLimits classSide methodsFor: 'example' stamp: 'BenjaminVanRyseghem 5/4/2011 11:10'!
example
	" self example "

	| window textMorph |
	textMorph := self 
					on: self
					text: #getText
					accept: nil.
	window := StandardWindow new.
	window addMorph: textMorph frame: (0@0 corner: 1@1).
	window openInWorld.
	window title: 'PluggableTextMorphWithLimits example'! !

!PluggableTextMorphWithLimits classSide methodsFor: 'example' stamp: 'BenjaminVanRyseghem 5/4/2011 11:13'!
getText

	^ '
" an example to show that comments are not counted " 

asdasf
a
s

d

f

as d            kfj.
ha,sdkjhfaksdjhfakjsdhfakjsh.
df.kajhsdf.kajhsdf.kjahsd.fkj.
ahs.dkja.sdkfjha.sdkfjha.skdjfh.kasjdhf.kasjd


hf.aksjdhfakjsdhfwuelriuweliuqywerliquyerliqwuyerlqiwuyerliq
								wuyerliqwuyerlqiuweyrlqiwueyrlqwieuyrlqwiueyrlqwieuyrlqiweuyrlqwiuerylqiwueyrlqiwueyrlqiwueyrlqwiuerylqiwueyrlqiweuyrlqwieuyrlqwiueyrlqweiuyrlqwieuryqlwiehfgh
								
								
							
						((ENTER RANDOM CHARACTERS NOW))'! !

!PluggableTextMorphWithLimits classSide methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/4/2011 11:16'!
ignoredCharacters

	^ { Character space. Character tab. Character cr. $.. $;. $:. $'. $(. $) }! !

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:37'!
resetDefaultWarningLimit
	" self resetDefaultWarningLimit "

	self defaultWarningLimit: nil! !

!PluggableTextMorphWithLimits classSide methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/4/2011 11:17'!
textSizeOf: aText

	| result count ignoredCharacters |
	result := 0.
	count := true.
	ignoredCharacters := self ignoredCharacters.
	aText do: [:char |
		(char = $")
			ifTrue: [ count := count not ]
			ifFalse: [
				((ignoredCharacters includes: char) not and: [ count ])
					ifTrue: [ result := result + 1 ]]].
	^ result.! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:34'!
alertLimit

		^ alertLimit ifNil: [ alertLimit := 2 * (self warningLimit) ]! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:34'!
alertLimit: anObject
	
		alertLimit := anObject! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:54'!
basicColor

	^ extension
		ifNil: [ color]
		ifNotNil: [ extension fillStyle ifNil: [ color ]].! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/3/2011 15:36'!
buildRectFrom: rect

	| top bottom right left hasVScroolbar |
	hasVScroolbar := 0.
	self vIsScrollbarShowing ifTrue: [ hasVScroolbar := 1 ].
	top := (rect bottom - StandardFonts defaultFont height - 4).
	bottom := rect bottom.
	right := rect right.
	left := right - (( self textSize printString size + 1 + hasVScroolbar ) * (StandardFonts defaultFont widthOf: $2)).
	^ (left@top corner: right@bottom)! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'bvr 8/23/2011 11:18'!
drawOn: aCanvas

	| rect top bottom left right stringColor size |
	super drawOn: aCanvas.
	size := self textSize.
	rect := self buildRectFrom: self bounds.
	
	stringColor := self stringColor.
	
	(self warningLimit negative or: [ self warningLimit isZero ])
		ifFalse: [ aCanvas drawString: size printString in: rect font: TextStyle defaultFont color: stringColor ].! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/3/2011 15:01'!
fillStyle
	"Return the current fillStyle of the receiver."
	
	| basicColor |
	basicColor := self basicColor.
	
	self warningLimit negative ifTrue: [ ^ basicColor ].
	
	textMorph ifNotNil: [ | size |
		size := self textSize.
		( size >= self warningLimit )
			ifTrue: [ | returnedColor length ratio limitColor |
				( size >= self alertLimit)
					ifTrue: [
						ratio := (size - self alertLimit) / 150.
						limitColor := Color orange.
						basicColor := Color yellow ]
					ifFalse: [
						length := self alertLimit - self warningLimit.
						ratio := (size - self warningLimit) / length.
						limitColor := Color yellow ].
					returnedColor := limitColor mixed: ratio with: basicColor.
					^ returnedColor ]].
	^ basicColor
! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 15:43'!
stringColor
	
	| size |
	size := self textSize.
	self warningLimit negative ifTrue: [ ^ Color black ].
	^ size >= self warningLimit
			ifTrue: [
				size >= self alertLimit
					ifTrue: [ Color red ]
					ifFalse: [ Color orange ]]
			ifFalse: [ Color black ].! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 14:41'!
textSize

	^ self class textSizeOf: self text! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:35'!
warningLimit

		^ warningLimit ifNil: [ warningLimit := self class defaultWarningLimit ]! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:34'!
warningLimit: anObject
	
		warningLimit := anObject! !
